import java.util.HashMap;
import java.util.LinkedList;

/**
 * la class Hamming crea una stringa di hamming.
 * Essa corregge anche il singolo errore.
 *Essa ha solo un metodo Costruttore che come  parametro prende una Stringa. 
 * 
 */
public class Hamming 
{
    private String input;
    private int numeroDiBitDiControllo;
    private int valoreIndexDellPotenzaDelDue [] ;    
    private int vetPotenze[];
    private int count; 
    private String hammingString;
    private  HashMap<Integer,Pair> valori;
    private String printaddBitDicontrollo;
    
    
    /**
     *  metodo Costruttore
     * 
     * @param _input
     */
    public Hamming(String _input)
    {
    	
		input = _input;
		numeroDiBitDiControllo = getBitDiControllo(input);
		valoreIndexDellPotenzaDelDue = new int[numeroDiBitDiControllo];
		hammingString = this.addBitDiControllo();
	     printaddBitDicontrollo=hammingString;
		valori=new  HashMap<Integer,Pair>();
		this.CalcolaBitdiParita();
		
    	
    }
   
    /** 
     * @return String
     *  il metodo restituisce la stringa di input
     */
    public String getInput()
    {
    	
    	
    	return input;
    }
    
   public String getprintaddBitDicontrollo()
   {
	   
	   
	   return  printaddBitDicontrollo;
   }
    
    /**
     *  il metodo setta una stringa di input
     * @param _input
     */
    public void setInput(String _input)
    {
    	
    	input=_input;
    	
    }
    
    /**
     *  il metodo restituisce il numero di bit  controllo 
     * @return int 
     */
   public int getnumeroDiBitDiControllo()
   {
	   
	   return numeroDiBitDiControllo;
   }
   
   
   
/**
 *   il metodo setta il numero di bit di controllo
 * 
 * @param _numeroDiBitDiControllo
 */
   public void  setNumeroDiBitDiControllo(int _numeroDiBitDiControllo)
   {
	   
	   
	   numeroDiBitDiControllo=_numeroDiBitDiControllo;
   }

	public int[] getValoreIndexDellPotenzaDelDue() 
	{
		return valoreIndexDellPotenzaDelDue;

	}
	  
	
	
	
	public HashMap<Integer,Pair>  getValori()
	{
		
		return valori;
		
	}
	public void  setValori(HashMap<Integer, Pair>_valori)
	{
		
		 valori=_valori;
		
	}
	
	/**
	 *   
	 *   Il metodo calcola il numero di bit controllo necessari per crea una stringa hamming
	 * 
	 */
	private int getBitDiControllo(String binary) 
	{
		int k = 1;
		int tot = 0;
		int n = binary.length();

		boolean controllo = true;
		while (controllo) 
		{
			tot = 2;
			for (int i = 1; i < k; i++) 
			{
				tot *= 2;

			}

			if (tot < k + n + 1) 
			{
				k++;
			} else 
			{
				controllo = false;
			}

		}

	    return k;

	}
	/**
	 *  il metodo crea una stringa. 
	 *  Negli indici che sono potenze del due aggiunge dei trattini 
	   sono  dei bit di controllo che verranno calcolati inseguito  
	 * 
	 */
	private String addBitDiControllo() 
	{

		String result = "";
		int j = 0;
		int x = 0;

		for (int i = 1; i <= numeroDiBitDiControllo + input.length(); i++) 
		{

			// verifico se l'indice se è una potenza del due
			// quindi è un bit di controllo
			if (IsPowerOfTwo(i)) {

				result += "-";
				// inserisco le potenza del due nell'array
				valoreIndexDellPotenzaDelDue[x++] = i;

			} else 
			{

				result += input.charAt(j++);
			}

		}

		return result;

	}
	
	/**il metodo verifica se un numero è una potenza del due
	 * 
	 * @param int  base
	 * @return boolean
	 */
	private static boolean IsPowerOfTwo(int base) 
	{
		final int DUE = 2;
		int resultLog = (int) (Math.log(base) / Math.log(DUE));
		int pot = base - (int) Math.pow(DUE, resultLog);
		if (pot == 0) {
			return true;
		}
		return false;
	}
	
	
	
	/** Trova tutte le potenze di 2 la cui somma e' n.
	 *  Gli esponenti cosi trovati vengono messi nel vettore vetPotenze. 
	 * La dimensione di vetPotenze viene memorizzata nella variabile count tipo intero. 
	 
	*/ 
	private void sommapot(int n) 
	{
		int k;

		k = (int) (Math.log(n) / Math.log(2)) + 1; // calcola la dimensione
													// massima di vetPotenze
		vetPotenze = new int[k]; // il vettore vetPotenze viene dimensionato
		  count = 0; // count conterra' il numero effettivo di elementi di
					// vetPotenze.

		while (n > 0) 
		{
			vetPotenze[count] = (int) (Math.log(n) / Math.log(2));
			n = n - (int) (Math.pow(2, vetPotenze[count]));
			count++;
		}

	}
	
	/**
	 * 
	 * il metodo restituisce una stringa di hamming
	 * @return String 
	 */
	public String createHamming()
	{   
		
		
		return hammingString;
	}
	
	public void setStringHamming(String _hammingString)
	{
		
		hammingString= _hammingString;
	}
	
	
	
	/**
	 *   il metodo calcola  l'indice dei bit che vengono controllati dal  
	 *   indice dal
	 *   bit di parita' 
	 *   
	 *
	 * @return LinkedList<Integer> 
	 */
	public HashMap<Integer, LinkedList<Integer>> getBitDiControllo() 
	{

		HashMap<Integer, LinkedList<Integer>> bitDiControllo = new HashMap<Integer, LinkedList<Integer>>();
		int[] array = getValoreIndexDellPotenzaDelDue();
		for (int i = 0; i < array.length; i++) {

			bitDiControllo.put(array[i], getIndexBitcontrollo(array[i],hammingString));

		}
		return bitDiControllo;

	}
	
	/** 
	 *  
	 *  il metodo calcola gli indici dei bit di controllo 
	 *  E' l'inserisci in una likedList semplice
	 * 
	 */
	private LinkedList<Integer>  getIndexBitcontrollo(int bit,String _hammingString) 
	{
		int potenza, i, j, x;
		 LinkedList<Integer> tmp=new LinkedList<Integer>();
	    	i = 1;
		potenza = 1;// conterra' di volta in volta le potenze di 2
					// (1,2,4,8,ecc...)
		while (i <= _hammingString.length()) {

			if (i == potenza) // se la posizione e' una potenza di 2
			{
				potenza = potenza * 2; // potenza  contiene la successiva potenza di 2
			} else 
			  {
				sommapot(i); // trova tutte le potenze di 2 la cui somma e' i e
				for (j = 0; j < count; j++) 
				{

					x = (int) (Math.pow(2, this.vetPotenze[j]));
					
				
					
					if (x == bit) 
					{

						tmp.add(i);

					}
					

				}

			}
			i = i + 1;
		}
		
		return tmp;

	}
	
	/**
	 *  Il metodo calcola i bit di parita'
	 *  
	 *
	 */
	
    public void CalcolaBitdiParita()
    { 
    	
    	HashMap<Integer,LinkedList<Integer>> tmpbitDiControllo=getBitDiControllo(); 
        
    	
		  
    	for(int i=0;i<valoreIndexDellPotenzaDelDue.length;i++)
    	{  
        	LinkedList<Integer> tmp=new LinkedList<Integer>();
    		for(int j=0;j<tmpbitDiControllo.get(valoreIndexDellPotenzaDelDue[i]).size();j++)
    		{
    			tmp.add(Integer.parseInt(""+hammingString.charAt(tmpbitDiControllo.get(valoreIndexDellPotenzaDelDue[i]).get(j)-1)));
    		  
    		}	
    		 if(hammingString.charAt(valoreIndexDellPotenzaDelDue[i]-1)=='-')
    		 {    
    		       int  xor=this.getXor(tmp);
    		       Pair pairTmp=new Pair(tmp,xor);
    		       valori.put(valoreIndexDellPotenzaDelDue[i],pairTmp);
    			   hammingString=hammingString.replaceFirst("-", ""+getXor(tmp));
    		      
    		 }
    	}
    	

    	
    }
	
	/**
	 * 
	 *  Il metodo calcola xor di una LinkedList
	 *  @param A
	 *  @return int
	 *   
	 */
	private int getXor(LinkedList<Integer> A) 
	{

		int result = A.get(0);
		for (int i = 1; i < A.size(); i++) 
		{
			result = (result ^ A.get(i));

		}
		return result;
	}
	 
	 
	/**
	 *   il metodo crea un errore sulla stringa di hamming il modo random.
	 *   Se il numero generato è uguale a 1 ad uno crea un errore sulla stringa su un indice random.
	 *   
	 *  Altrimenti se il numero generato è uguale a 2 non crea nessun errore
	 *  
	 * 
	 * @param hamming
	 * @return String
	 */
	public String createError(String hamming)
	{     String error="";
		  int  index = (int)(Math.random()*2)+1;
		  if(index==1)
		  {  
		 
		 int indexRandom=this.getIndexRandam();
		 
         for(int i=0;i<hamming.length();i++)
         {   
        	 if(i==indexRandom-1)
        	 {   if(hamming.charAt(i)=='0'){
        		 error+="1";
        	   }else 
        	   {
        		   
        		   error+="0";
        	   } 
        		 
        	 }else
        	 {
        		 
        		 error+=hamming.charAt(i);
        	 }
        	 
        	 
         }
         
		}else
		{
			
			error=hamming;
		}
         
         return error;
		
		
	}
	
	/**
	 *  
	 *  Il verifica se il bit di parita' e'corretto
	 * 
	 * @param tmp
	 * @return boolean 
	 */
	 public  boolean verificaLaParita(LinkedList<Integer> tmp)
	 {
		int countUno=0;
		 for(int i=0;i<tmp.size();i++)
		 {
			 
			 if(tmp.get(i)==1)
			 {
				 
				 countUno++;
			 }
			 
			
		 }
		 if((countUno%2)==0)
		 {
			return true; 
		 }
		 
		 return false;
				 
		 
	 }
	 
	 public HashMap<Integer,LinkedList<Integer>> getBitdiParita()
	    { 
	    	
	    	HashMap<Integer,LinkedList<Integer>> tmpbitDiControllo=getBitDiControllo(); 
	    	HashMap<Integer,LinkedList<Integer>> valoriBit=new HashMap<Integer,LinkedList<Integer>>();
	    	
			  
	    	for(int i=0;i<valoreIndexDellPotenzaDelDue.length;i++)
	    	{  //  System.out.println("1");
	        	LinkedList<Integer> tmp=new LinkedList<Integer>();
	    		for(int j=0;j<tmpbitDiControllo.get(valoreIndexDellPotenzaDelDue[i]).size();j++)
	    		{   
	    			tmp.add(Integer.parseInt(""+hammingString.charAt(tmpbitDiControllo.get(valoreIndexDellPotenzaDelDue[i]).get(j)-1)));
	    		
	    		}	
	    		  tmp.add(Integer.parseInt(""+hammingString.charAt(valoreIndexDellPotenzaDelDue[i]-1)));
	    		 
	    	       	valoriBit.put(valoreIndexDellPotenzaDelDue[i],tmp);
	    			
	    		      
	    		 
	    	}
	    	
	    	return valoriBit;
	    	
	    }
	 /**
	  *  Il metodo restituisce  i bit di parita' errati
	  * 
	  * @return LinkedList<Integer>
	  */
	 
	 public LinkedList<Integer> getErrorBitDiParita()
	 {
		 LinkedList<Integer> errorBitParita=new  LinkedList<Integer>();
	    	for(int i=0;i<getValoreIndexDellPotenzaDelDue().length;i++)
	    	{	
	    	if(!verificaLaParita(getBitdiParita().get(getValoreIndexDellPotenzaDelDue()[i])))
	    	{
	    		 errorBitParita.add(getValoreIndexDellPotenzaDelDue()[i]);
	    	}	
	    	
	    	}
	    	
	    	
	    	return errorBitParita;
		 
		 
	 }
	 
	 /**
	  *  Il metodo restituisce  l' indice  errat0
	  * 
	  * @return int
	  */
   public int IndexBitErrato()
    {
    	int index=0;
    	 LinkedList<Integer> errorBitParita=getErrorBitDiParita();
    	if(errorBitParita.size()>0)
    	{
    		 for(int i=0;i<errorBitParita.size();i++)
        	 {
        		 
        		 index+=errorBitParita.get(i);
        	 }
    		 
    		return index;
    	}	
    	
    	return -1;
    }
	 
	 /**
	  * 
	  *  il metodo genera il modo random l'indice dove crea un errore
	  *  
	  *  
	  */
	 public int getIndexRandam()
	 {    int y=this.hammingString.length()+1;
		 int  index = (int)(Math.random()*(y-1))+1;
         return index;
         
        	
         
         
	      
       
	 }
	 
	 /**
	  *  Il metodo corregge la stringa errata
	  *  @return String 
	  */

     public String getCorrect()
     {
    	 String stringCorrect="";
    	 int index=IndexBitErrato();
    	 if(index!=-1)
    	 { 
    	 for(int i=0;i<createHamming().length();i++)
         {
        	 
        	 if(i==index-1)
        	 {  
        		if(createHamming().charAt(i)=='0')
        		{
        			stringCorrect+="1";
        		}else
        		{
        			
        			stringCorrect+="0";
        		}
        		
        		 
         	 }else
         	 {
         		 stringCorrect+=createHamming().charAt(i);
         		 
         	 } 
        	 
         }
    	 }else
    	 {
    		 stringCorrect+="-1";
    	 }
    	 
    	 return stringCorrect;
    	 
    	 
     }
  
     
     
      
	 
	 
	

}
